#!/usr/bin/env python
# -*- coding:utf-8 -*-
# @FileName  :plt.py
# @Time      :2025/5/12 13:46
# @Author    :David
# @Company: shenyang JY
import matplotlib.pyplot as plt


def paint_map(self):
    """
    根据风机经纬度，绘制经纬度地图
    :return:
    """
    lats = self.info['纬度'].values
    lons = self.info['经度'].values
    map = Basemap()

    # 绘制海岸线和国家边界
    map.drawcoastlines()
    map.drawcountries()

    # 绘制经纬度坐标
    map.drawmeridians(range(0, 360, 30))
    map.drawparallels(range(-90, 90, 30))

    # 绘制点

    x, y = map(lons, lats)
    map.plot(x, y, 'bo', markersize=10)

    # 显示图表
    plt.show()


def paint_power15min(self):
    """
    绘制15分钟功率曲线
    :return:
    """

    plt.plot(self.power_15min['C_REAL_VALUE'])

    # 设置图表标题和轴标签
    plt.title('Data Time Change Curve')
    plt.xlabel('Date')
    plt.ylabel('Value')

    # 显示图表
    plt.show()

def paint_lats_lons(self):
    """
    绘制经纬度图
    :return:
    """
    x = self.info['纬度'].values
    y = self.info['经度'].values

    # 绘制散点图
    fig, ax = plt.subplots()
    plt.scatter(x, y)

    for i, txt in enumerate(self.info['id'].values):
        ax.annotate(txt, (x[i], y[i]))

    # 设置图表标题和轴标签
    plt.xlabel('lats')
    plt.ylabel('lons')

    # 显示图表
    plt.show()


if __name__ == "__main__":
    run_code = 0
